unit CalMakerUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCalMakerForm = class(TForm)
    Label1: TLabel;
    LoEdit: TEdit;
    Label2: TLabel;
    HiEdit: TEdit;
    MakeButton: TButton;
    Memo1: TMemo;
    procedure MakeButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    bGoAhead: Boolean;
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  DFileStreams;

procedure TCalMakerForm.MakeButtonClick(Sender: TObject);
const
  NybbleToHex: array[0..15] of AnsiChar = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');

var
  I, J: Integer;
  LoCt, HiCt: Integer;
  F: Double;
  Fil: TDFileStream;
  Buf: AnsiString;

begin
  LoCt := StrToInt('$' + LoEdit.Text);
  HiCt := StrToInt('$' + HiEdit.Text);

  MakeButton.Enabled := False;

  SetLength(Buf, $70000);

  for I := 0 to $FFFF do begin
    F := (I - 0) / 65536;
    F := F * (HiCt - LoCt) + LoCt;
    J := Round(F);
    //Fil.WriteStr('$' + IntToHex(J, 4) + #13#10);
    Buf[I * 7 + 7] := #10;
    Buf[I * 7 + 6] := #13;
    Buf[I * 7 + 5] := NybbleToHex[J and $F];
    J := J shr 4;
    Buf[I * 7 + 4] := NybbleToHex[J and $F];
    J := J shr 4;
    Buf[I * 7 + 3] := NybbleToHex[J and $F];
    J := J shr 4;
    Buf[I * 7 + 2] := NybbleToHex[J and $F];
    Buf[I * 7 + 1] := '$';
  end;

  Fil := TDFileStream.Create('Cal.txt', dfCreateOrReplace + dfWrite);
  Fil.WriteStr(Buf);
  Fil.Free;

  MakeButton.Enabled := True;

  Beep;
  Memo1.Lines.Add('Calibration Table File created as Cal.txt');
end;

procedure TCalMakerForm.FormCreate(Sender: TObject);
begin
  bGoAhead := True;
end;

end.
